with Reps;
use Reps;

package Checkbif is

   procedure Check_PF(Size, PartSize: in Positive; QName: in String;
                      DA,DL,R1,R2,R3,R4,R5: in Radius; Div: in Integer);
   procedure Check_Int(Size, PartSize: in Positive; QName: in String;
                       DA,DL,R1,R2,R3: in Radius);
   procedure Check_Fold(Size, PartSize: in Positive; QName: in String;
                        DA,DL,R1,R2,R3,R4: in Radius; Div: in Integer);
   procedure Check_FoldR(Size, PartSize: in Positive; QName: in String;
                         DA,DL,R1,R2,R3,R4: in Radius; Div: in Integer);

-- these procedures prove that in a neighborhood of radius R1 of a Fourier
-- polynomial there exists a bifurcation of pitchfork, intersection or fold type

-- Size: number of Fourier modes explicitely computed
-- PartSize: dimension of the approximation M (formulas 3.2 and 3.7)
-- QName: file with approximate bifurcation point
-- DA: half-width of the interval I in Lemma 3.4 or equivalent
-- DL: half-width of the interval J in Lemma 3.4 or equivalent
-- R1: radius of the ball used in checking assumption (1) and (2) in Lemma 3.4
-- R2: radius of the ball used in checking assumption (3) in Lemma 3.4
-- R3: radius of the ball used in checking assumption (5) in Lemma 3.4
-- R4: radius of the ball used in checking assumption (4) in Lemma 3.4
-- R5: radius of the ball used in checking assumption (1) and (2) in Lemma 3.4
-- Div: number of divisions in the lambda direction

end Checkbif;
