with Reps;
use Reps;

procedure CheckBranch(Size, PartSize: in Positive; QName1: in String;
                      R1,DA1,DL1: in Radius; QName2: in String;
                      R2,DA2,DL2: in Radius; DLStart: in Rep; Err: in Radius);

-- check the existence of a smooth branch between two bifurcations, or
-- between a bifurcation and an end point

-- Size: number of Fourier modes explicitely computed
-- PartSize: dimension of the approximation M (formulas 3.2 and 3.7)
-- QName1: file with approximate first bifurcation point
-- R1: radius of the ball where the first bifurcation is proved to be
-- DA1: half-width of the interval I in Lemma 3.4 or equivalent for the 1st bif
-- DL1: half-width of the interval J in Lemma 3.4 or equivalent for the 1st bif
-- QName2, R2, DA2, DL: the same for the 2nd bifurcation
-- if the branch goes to an endpoint, then QName2="", R2=DA2=DL=0.0
-- DLStart: approximate value of lambda where the bifurcation branch begins
-- Err: tolerance for the Newton algorithm
