
generic

  with function "-"(S: Scalar) return Scalar is <>;
  with procedure Split(S: in Scalar; S0,SE: out Scalar) is <>;
  with function "+"(S,T: Scalar) return Scalar is <>;
  with function "-"(S,T: Scalar) return Scalar is <>;
  with function "*"(R: Rep; S: Scalar) return Scalar is <>;
  with function "/"(S: Scalar; R: Rep) return Scalar is <>;
  with function Sqr(S: Scalar) return Scalar is <>;
  with function "*"(S,T: Scalar) return Scalar is <>;
  with function Inv(S: Scalar) return Scalar is <>;
  with function "/"(S,T: Scalar) return Scalar is <>;
  with function "**"(S: Scalar; I: Integer) return Scalar is <>;
  with function Exp(S: Scalar) return Scalar is <>;
  with function Log(S: Scalar) return Scalar is <>;
  with function Sqrt(S: Scalar) return Scalar is <>;

package Fouriers.Ops is

  function "+"(F,G: Fourier) return Fourier;                           -- F+G
  function "-"(F,G: Fourier) return Fourier;                           -- F-G
  function "-"(H: Fourier) return Fourier;                             -- -H
  function "*"(S: Scalar; F: Fourier) return Fourier;                  -- S*H
  function "*"(H1,H2: Fourier) return Fourier;                         -- H*H
  function "*"(H1,H2: Fourier) return Scalar ;                         -- (H1,H2) inner product
  function Norm(H: Fourier) return Scalar;                             -- Norm := ||H||_Rho(H)
  function L2Norm(H: Fourier) return Scalar;                           -- L2 norm
  function D(K: Positive; H: Fourier) return Fourier;                  -- D^K H  (polynomials)
  function D(H: Fourier; R: Radius) return Fourier;                    -- D H
  function Dinv(B,C: Scalar; H: Fourier) return Fourier;               -- C*[1+B*D^(-2)]^(-1) H
  function Dinv(K: Positive; C: Scalar; H: Fourier) return Fourier;    -- C*D^(-K) H
  function Dinv(K: Positive; B,C: Scalar; H: Fourier) return Fourier;  -- C*[D^K(D^2+B)]^(-1) H
  procedure ZeroConstant(H: in out Fourier);                           -- set constant part =0
  procedure Split(N: in Freq; H: in Fourier; Hl,Hh: out Fourier);      -- split into low/high modes
  procedure SplitLowErr(N: in Freq; H: in out Fourier; E: out Scalar); -- split off error terms for low modes
  procedure Split(H: in Fourier; Hl,Hh: out Fourier);                  -- split into poly/errors
  procedure GuessRho(H: in Fourier; R: out Rep);                       -- guess domain of analyticity
  procedure CleanUp(H: in out Fourier);                                -- cleans small values of coeffs
  function Alpha4(H: Fourier) return Fourier;                          -- alpha -> 4*alpha

private

  procedure SetParam(P: in Boolean; J: in Parity; R: in Radius; H: in out Fourier);
  procedure Diag(H1: in Fourier; F: in ScalVecE; H2: out Fourier);
  function MinDeg(H: Fourier) return Integer;

end Fouriers.Ops;
