with Reps.IO;
use Reps.IO;

package body Intervals.IO is

  procedure Show(S: in Interval; NewLine: in Boolean := True) is
    C: constant Rep := Half*(S.U-S.L);
    R: constant Rep := Half*(S.U+S.L);
  begin
    Txt_Put(Current_Output,C);   --- approximate
    if R /= Zero then
      Put(" [");
      Txt_Put(Current_Output,R); --- approximate
      Put(" ]");
    end if;
    if NewLine then New_Line; end if;
  end Show;

  procedure Get(F: in File_Type; S: out Interval; Decimal: in Boolean := True) is
  begin
    Txt_Get(F,S.L,S.U,Decimal);
    S.L := -S.L;
  end Get;

  procedure Put(F: in File_Type; S: in Interval; Decimal: in Boolean := True) is
    C: constant Rep := Half*(S.U-S.L);
  begin
    if Decimal then
      Txt_Put(F,C,Decimal);         --- approximate
    else
      Txt_Put(F,-S.L,S.U,Decimal);  --- [Inf(S),Sup(S)]
    end if;
  end Put;

end Intervals.IO;
