
package Intervals.Ops is

  pragma Elaborate_Body;

  function Approx(S: Interval) return Rep;
  procedure Split(S: in Interval; S0,SE: out Interval);
  function Piece(M,N: Positive; S: Interval) return Interval;

  function "+"(S,T: Interval) return Interval;
  function "-"(S,T: Interval) return Interval;
  function "*"(R: Rep; S: Interval) return Interval;
  function "/"(S: Interval; R: Rep) return Interval;
  function Sqr(S: Interval) return Interval;
  function "*"(S,T: Interval) return Interval;
  function Inv(S: Interval) return Interval;
  function "/"(S,T: Interval) return Interval;
  function "**"(S: Interval; I: Integer) return Interval;

  procedure CoshSinh(S: in Interval; Sc,Ss: out Interval);
  function Exp(S: Interval) return Interval;
  function Log(S: Interval) return Interval;
  function Sqrt(S: Interval) return Interval;
  function Widen(S: Interval) return Interval;
  procedure Root4(C0,C1,C3: in Interval; S0: in Radius; S: out Interval; Exists: out Boolean);

  pragma Inline ("+","-","*",Sqr,Inv,"/");

end Intervals.Ops;
