
package body Intervals is

  function IsNumeric(S: Interval) return Boolean is
  begin
    return False;
  end IsNumeric;

  function Scal(K: Integer) return Interval is
  begin
    return (Rep(K),Rep(-K));
  end Scal;

  function Scal(R: Rep) return Interval is
  begin
    return (R,-R);
  end Scal;

  function Scal(R1,R2: Rep) return Interval is
  begin
    if R2>R1 then return (R2,-R1); end if;
    return (R1,-R2);
  end Scal;

  function Ball(R: Rep) return Interval is
  begin
    if R >= Zero then return (R,R); end if;
    return (-R,-R);
  end Ball;

  function Ball(S: Interval) return Interval is
  begin
    if S.U>S.L then return (S.U,S.U); end if;
    return (S.L,S.L);
  end Ball;

  function Inf(S: Interval) return Rep is
  begin
    return -S.L;
  end Inf;

  function Sup(S: Interval) return Rep is
  begin
    return S.U;
  end Sup;

  function "abs"(S: Interval) return Interval is
  begin
    if S.L <= Zero then return S; end if;
    if S.U <= Zero then return (S.L,S.U); end if;
    return (Rep'Max(S.U,S.L),Zero);
  end "abs";

  function InfAbs(S: Interval) return Rep is
  begin
    if S.L <= Zero then return -S.L; end if;
    if S.U <= Zero then return -S.U; end if;
    return Zero;
  end InfAbs;

  function SupAbs(S: Interval) return Rep is
  begin
    return Rep'Max(S.U,S.L);
  end SupAbs;

  function Min(S1,S2: Interval) return Interval is
  begin
    return (Rep'Min(S1.U,S2.U),Rep'Max(S1.L,S2.L));
  end Min;

  function Max(S1,S2: Interval) return Interval is
  begin
    return (Rep'Max(S1.U,S2.U),Rep'Min(S1.L,S2.L));
  end Max;

  function Envelope(S1,S2: Interval) return Interval is
  begin
    return (Rep'Max(S1.U,S2.U),Rep'Max(S1.L,S2.L));
  end Envelope;

  function "<"(S1,S2: Interval) return Boolean is
  begin
    if S1.U < -S2.L then return True; end if;
    if -S1.L < S2.U then raise Undefined; end if;
    return False;
  end "<";

  function "-"(S: Interval) return Interval is
  begin
    return (S.L,S.U);
  end "-";

end Intervals;
