with Reps;
use Reps;

package Intervals is

  pragma Pure;

  type Interval is private;

  function IsNumeric(S: Interval) return Boolean;
  function Scal(K: Integer) return Interval;
  function Scal(R: Rep) return Interval;
  function Scal(R1,R2: Rep) return Interval;
  function Ball(R: Rep) return Interval;
  function Ball(S: Interval) return Interval;
  function Inf(S: Interval) return Rep;
  function Sup(S: Interval) return Rep;
  function "abs"(S: Interval) return Interval;
  function InfAbs(S: Interval) return Rep;
  function SupAbs(S: Interval) return Rep;
  function Min(S1,S2: Interval) return Interval;
  function Max(S1,S2: Interval) return Interval;
  function Envelope(S1,S2: Interval) return Interval;
  function "<"(S1,S2: Interval) return Boolean;
  function "-"(S: Interval) return Interval;

  pragma Inline (Inf,Sup,"abs","-");

private

  type Interval is
    record
      U: Rep;   -- upper bound
      L: Rep;   -- minus lower bound
    end record;

end Intervals;
