
package Linear.IO is

  pragma Elaborate_Body;

  procedure Read(Name: in String; B: out Vector; Bin: in Boolean := False);  -- Read B from Name (text/binary)
  procedure Read(Name: in String; A: out Matrix; Bin: in Boolean := False);  -- Read A from Name (text/binary)
  procedure Write(Name: in String; B: in Vector; Bin: in Boolean := False);  -- Write B to Name (text/binary)
  procedure Write(Name: in String; A: in Matrix; Bin: in Boolean := False);  -- Write A to Name (text/binary)

  procedure Show(P: in Pivot; L: in Integer := Integer'Last);                -- Display P(I) with I<=L
  procedure Show(B: in Vector; Cut: in Rep := Zero);                         -- Display elements>Cut of B
  procedure Show(B1,B2: in Vector; Cut: in Rep := Zero);                     -- Display elements>Cut of B1 and B2
  procedure Show(A: in Matrix; Cut: in Rep := Zero);                         -- Display elements>Cut of A
  procedure Show(A1,A2: in Matrix; Cut: in Rep := Zero);                     -- Display elements>Cut of A1 and A2

private

  procedure BinRead(Name: in String; B: out Vector);                         -- Read B from Name, binary format
  procedure TextRead(Name: in String; B: out Vector);                        -- Read B from Name, ascii format
  procedure BinRead(Name: in String; A: out Matrix);                         -- Read A from Name, binary format
  procedure TextRead(Name: in String; A: out Matrix);                        -- Read A from Name, ascii format
  procedure BinWrite(Name: in String; B: in Vector);                         -- Write B to Name, binary format
  procedure TextWrite(Name: in String; B: in Vector);                        -- Write B to Name, ascii format
  procedure BinWrite(Name: in String; A: in Matrix);                         -- Write A to Name, binary format
  procedure TextWrite(Name: in String; A: in Matrix);                        -- Write A to Name, ascii format

end Linear.IO;
