with Reps;
use Reps;

package Linear is

  pragma Pure;

  type Vector is array(Integer range <>) of Rep;
  type Pivot is array(Integer range <>) of Integer;
  type Matrix is array(Integer range <>, Integer range <>) of Rep;

  Matrix_Singular: exception;
  Getting_Tired: exception;

  procedure SetZero(B: out Vector);                                   -- B := 0
  procedure SetZero(A: out Matrix);                                   -- A := 0
  procedure SetColumn(J: in Integer; V: in Vector; A: in out Matrix); -- A(.,J) := V
  function GetColumn(J: Integer; A: Matrix) return Vector;            -- V := A(.,J)

end Linear;
