with Reps.Ops, Ada.Numerics.Generic_Elementary_Functions;

pragma Elaborate_All (Ada.Numerics.Generic_Elementary_Functions);

package body Numerics.Ops is

  package Numeric_EF is new Ada.Numerics.Generic_Elementary_Functions(Numeric);

  function Exp(S: Numeric) return Numeric renames Numeric_EF.Exp;
  function Log(S: Numeric) return Numeric renames Numeric_EF.Log;
  function Sqrt(S: Numeric) return Numeric renames Numeric_EF.Sqrt;
  function Widen(S: Numeric) return Numeric renames Ball;

  procedure Root4(C0,C1,C3: in Numeric; S0: in Radius; S: out Numeric; Exists: out Boolean) is
    use Reps.Ops;
    R: Rep;
  begin
    Root4(Rep(C0),Rep(C1),Rep(C3),S0,R,Exists);
    S := Numeric(R);
  end Root4;

end Numerics.Ops;
