
package body Qs.IO is

  package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
  use Txt_Int_IO;

  procedure Show(H: in Q; Cut: in Rep := Zero) is
  begin
     for I in Part loop
        Put_Line("Mode number" & I'Img);
        Show(H(I),Cut);
     end loop;
  end Show;

  procedure Put(F: in File_Type; H: in Q; Decimal: in Boolean := True) is
  begin
    Put(F,Number);
    New_Line(F);
    for I in Part loop
      Put(F,H(I),Decimal);
    end loop;
  end Put;

  procedure Write(Name: in String; A: in Scalar; H: in Q; Decimal: in Boolean := True) is
    F: File_Type;
  begin
--    Put_Line("Writing " & Name);
    Create(F,Out_File,Name);
    Put(F,A,Decimal);
    New_Line(F);
    Put(F,H,Decimal);
    Close(F);
  end Write;

  procedure Get(F: in File_Type; J: in Parity; H: out Q; Decimal: in Boolean := True) is
    N: Integer;
  begin
    Get(F,N);
    for I in Part loop
       if I<=N then
          Get(F,J,H(I),Decimal);
       else
          SetZero(J,Rho(H(1)),H(I));
       end if;
    end loop;
    if N>Number then
       Put_Line("Warning: Input truncated");
    end if;
  end Get;

  procedure Read(Name: in String; J: in Parity; A: out Scalar; H: out Q; Decimal: in Boolean := True) is
    F: File_Type;
  begin
    Put_Line("Reading " & Name);
    Open(F,In_File,Name);
    Get(F,A,Decimal);
    Get(F,J,H,Decimal);
    Close(F);
  end Read;

end Qs.IO;
