with Fouriers.IO, Ada.Text_IO, SLinear.IO;
use Ada.Text_IO;

pragma Elaborate_All (Fouriers.IO);

generic

  with procedure Show(S: in Scalar; NewLine: in Boolean := True) is <>;
  with procedure Get(F: in File_Type; S: out Scalar; Decimal: in Boolean := True) is <>;
  with procedure Put(F: in File_Type; S: in Scalar; Decimal: in Boolean := True) is <>;

package Qs.IO is

   package Components_IO is new Components.IO;
   package QSLinear_IO is new QSLinear.IO;
   use Components_IO;

   procedure Show(H: in Q; Cut: in Rep := Zero);            -- Show coeffs of H  (of modulus>Cut)
   procedure Put(F: in File_Type; H: in Q;                  -- Write H to file F
                 Decimal: in Boolean := True);
   procedure Write(Name: in String; A: in Scalar; H: in Q;  -- Write A,H to file Name
                   Decimal: in Boolean := True);
   procedure Get(F: in File_Type; J: in Parity; H: out Q;   -- Read H from file
                Decimal: in Boolean := True);
   procedure Read(Name: in String; J: in Parity;            -- Read A,H from file Name
                  A: out Scalar; H: out Q;
                  Decimal: in Boolean := True);

end Qs.IO;
