with Reps;
use Reps;

generic

  type Scalar is private;

  with function IsNumeric(S: Scalar) return Boolean is <>;
  with function Scal(K: Integer) return Scalar is <>;
  with function Scal(R: Rep) return Scalar is <>;
  with function Ball(R: Rep) return Scalar is <>;
  with function Ball(S: Scalar) return Scalar is <>;
  with function "<"(S1,S2: Scalar) return Boolean is <>;
  with function Approx(S: Scalar) return Rep is <>;
  with function Inf(S: Scalar) return Rep is <>;
  with function Sup(S: Scalar) return Rep is <>;
  with function InfAbs(S: Scalar) return Rep is <>;
  with function SupAbs(S: Scalar) return Rep is <>;
  with function "abs"(S: Scalar) return Scalar is <>;
  with function Min(S1,S2: Scalar) return Scalar is <>;
  with function Max(S1,S2: Scalar) return Scalar is <>;
  with function Envelope(S1,S2: Scalar) return Scalar is <>;

package SLinear is

  pragma Pure;

  type SVector is array(Integer range <>) of Scalar;
  type SMatrix is array(Integer range <>, Integer range <>) of Scalar;

  Matrix_Singular: exception;
  Getting_Tired: exception;

  procedure SetZero(B: out SVector);                                    -- B := 0
  procedure SetZero(A: out SMatrix);                                    -- A := 0
  procedure SetColumn(J: in Integer; V: in SVector; A: in out SMatrix); -- A(.,J) := V

end SLinear;
